# module Chef::Mixin::ShellOut

### Constants

DEPRECATED_OPTIONS

### Public Instance Methods

run_command_compatible_options(command_args) click to toggle source

CHEF-3090: Deprecate command_log_level and command_log_prepend Patterned after github.com/opscode/chef/commit/e1509990b559984b43e428d4d801c394e970f432

    # File lib/chef/mixin/shell_out.rb, line 53
    def run_command_compatible_options(command_args)
      return command_args unless command_args.last.is_a?(Hash)

      _command_args = command_args.dup
      _options = _command_args.last

      DEPRECATED_OPTIONS.each do |old_option, new_option|
        # Edge case: someone specifies :command_log_level and 'command_log_level' in the option hash
        next unless value = _options.delete(old_option) || _options.delete(old_option.to_s)
        deprecate_option old_option, new_option
        _options[new_option] = value
      end

      return _command_args
    end

shell_out(*command_args) click to toggle source

#shell_out! runs a command on the system and will raise an error if the command fails, which is what you want for debugging, #shell_out and #shell_out! both will display command output to the tty when the log level is debug Generally speaking, 'extend Chef::Mixin::ShellOut' in your recipes and include 'Chef::Mixin::ShellOut' in your LWRPs You can also call Mixlib::Shellout.new directly, but you lose all of the above functionality

    # File lib/chef/mixin/shell_out.rb, line 34
    def shell_out(*command_args)
      cmd = Mixlib::ShellOut.new(*run_command_compatible_options(command_args))
      cmd.live_stream = io_for_live_stream
      cmd.run_command
      cmd
    end

shell_out!(*command_args) click to toggle source

    # File lib/chef/mixin/shell_out.rb, line 41
    def shell_out!(*command_args)
      cmd= shell_out(*command_args)
      cmd.error!
      cmd
    end